#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "listacab.h"

/*en esta implementacin, una posicin es un puntero al nodo anterior al que
contiene al elemento en cuestin. La posicin del primer elemento es la cabecera
de la lista, y la posicin "fin" es un puntero al ltimo nodo*/

/*******funciones internas***************/
static void error(const char *mensaje)
{
 printf("%s.\n",mensaje);
}

static int igual(telemento a,telemento b)
{
 if(!strcmp(a,b)) return 1;
 else return 0;
}
/******funciones publicas**************/
lista crearlista()
{
 lista l;
 l=(lista)malloc(sizeof(tiponodo));
 if(l==NULL)
  error("crearlista: no hay memoria");
 l->sig=NULL;
 return l;
}

void destruirlista(lista l)
{
 posicion p;
 while(l!=NULL)
 {
  p=l;
  l=p->sig;
  free(p);
 }
}

void insertar(telemento x,posicion p,lista l)
{
 posicion q;
 q=(posicion)malloc(sizeof(tiponodo));
 if(q==NULL)
  error("insertar: no hay memoria");
 strcpy(q->elemento,x); /*hay que hacer una copia de la cadena para evitar efectos laterales*/
 q->sig=p->sig;
 p->sig=q;
}

void eliminar(posicion p,lista l)
{
 posicion q;
 if(p->sig==NULL) /*una pequea comprobacin preliminar*/
  error("eliminar: elemento inexistente");
 q=p->sig;
 p->sig=q->sig;
 free(q);
}

posicion anterior(posicion p,lista l)
/*esta funcin resultara mucho ms eficiente con las listas doblemente enlazadas*/
/*utilizo esta implementacin de lista porque no uso esta funcin en mi ejercicio*/
/*si la usara frecuentemente debera incluir una lista doblemente enlazada y no sta*/
{
 posicion q;
 if(p==l)
  error("anterior: posicion incorrecta"); /*no existe elemento anterior al primero*/
 q=l;
 while(q->sig!=p)
  q=q->sig;
 return q;
}

posicion fin(lista l)
{
 posicion p;
 p=l;
 while(p->sig!=NULL)
  p=p->sig;
 return p;
}

posicion primera(lista l)
{
 if(l==NULL)
  error("primera: lista vacia");
 else
  return l;
}

posicion siguiente(posicion p,lista l)
{
 if(l==NULL)
  error("siguiente: lista vacia");
 else
 {
  if(p==NULL)
   error("siguiente: posicion incorrecta");
  else return p->sig;
 }
}

posicion buscar(telemento x,lista l)
{
 posicion p=l;
 int encontrado=0;
 while(p!=fin(l)&&!encontrado)
  if(igual(p->sig->elemento,x))
   encontrado=1;
  else p=p->sig;

 return p;
}

telemento recuperar(posicion p,lista l)
{
 if(l==NULL)
  error("recuperar: lista vacia");
 else
  if(p==NULL)
   error("recuperar: posicion incorrecta");
 return p->sig->elemento;
}
